#include <stdio.h>
#include <stdlib.h>
#if defined(WIN32)
//#  pragma comment(linker, "/subsystem:\"windows\" /entry:\"mainCRTStartup\"")
#  pragma comment(lib, "glew32.lib")
#  include "glew.h"
#  include "glut.h"
#  include "glext.h"
#elif defined(__APPLE__) || defined(MACOSX)
#  include <GLUT/glut.h>
#else
#  define GL_GLEXT_PROTOTYPES
#  include <GL/glut.h>
#endif

/*
** Υץɤ߹ߤ˻Ȥؿ
*/
extern int readShaderSource(GLuint shader, const char *file);
extern void printShaderInfoLog(GLuint shader);
extern void printProgramInfoLog(GLuint program);

/*
** ֥
*/
static GLuint vertShader;
static GLuint fragShader;
static GLuint gl2Program;

/*
** Ѵ
*/
extern void orthogonalMatrix(float left, float right,
                             float bottom, float top,
                             float near, float far,
                             GLfloat *matrix);
extern void perspectiveMatrix(float left, float right,
                              float bottom, float top,
                              float near, float far,
                              GLfloat *matrix);
extern void cameraMatrix(float fovy, float aspect, float near, float far,
                         GLfloat *matrix);
static GLfloat projectionMatrix[16];
static GLint projectionMatrixLocation;

/*
** Ѵ
*/
extern void lookAt(float ex, float ey, float ez,
                   float tx, float ty, float tz,
                   float ux, float uy, float uz,
                   GLfloat *matrix);
extern void multiplyMatrix(const GLfloat *m0,
                           const GLfloat *m1,
                           GLfloat *matrix);

/*
** attribute ѿ position ĺХåե֥
*/
static GLuint buffer;

/*
** ɽ
*/
static void display(void)
{
  /* ̥ꥢ */
  glClear(GL_COLOR_BUFFER_BIT);

  /* ץŬѤ */
  glUseProgram(gl2Program);

  /* uniform ѿ projectionMatrix ˹ꤹ */
  glUniformMatrix4fv(projectionMatrixLocation, 1, GL_FALSE, projectionMatrix);

  /* index  0  attribute ѿĺбդ */
  glEnableVertexAttribArray(0);

  /* ĺХåե֥ȤȤ buffer ꤹ */
  glBindBuffer(GL_ARRAY_BUFFER, buffer);

  /* ĺγǼȽ񼰤ꤹ */
  glVertexAttribPointer(0, 2, GL_FLOAT, GL_FALSE, 0, 0);

  /* ޷ */
  glDrawArrays(GL_LINE_LOOP, 0, 4);

  /* ĺХåե֥Ȥ */
  glBindBuffer(GL_ARRAY_BUFFER, 0);

  /* index  0  attribute ѿĺȤбդ */
  glDisableVertexAttribArray(0);

  glFlush();
}

/*
** 
*/
static void init(void)
{
  /* ץΥѥ롿󥯷̤ѿ */
  GLint compiled, linked;

  /* ĺХåե֥ȤΥ򻲾Ȥݥ */
  typedef GLfloat Position[2];
  Position *position;

  /* ŪѴ */
  GLfloat temp0[16], temp1[16];

#if defined(WIN32)
  /* GLEW ν */
  GLenum err = glewInit();
  if (err != GLEW_OK) {
    fprintf(stderr, "Error: %s\n", glewGetErrorString(err));
    exit(1);
  }
#endif

  /* طʿ */
  glClearColor(1.0, 1.0, 1.0, 1.0);

  /* ֥Ȥκ */
  vertShader = glCreateShader(GL_VERTEX_SHADER);
  fragShader = glCreateShader(GL_FRAGMENT_SHADER);

  /* Υץɤ߹ */
  if (readShaderSource(vertShader, "simple.vert")) exit(1);
  if (readShaderSource(fragShader, "simple.frag")) exit(1);

  /* СƥåΥץΥѥ */
  glCompileShader(vertShader);
  glGetShaderiv(vertShader, GL_COMPILE_STATUS, &compiled);
  printShaderInfoLog(vertShader);
  if (compiled == GL_FALSE) {
    fprintf(stderr, "Compile error in vertex shader.\n");
    exit(1);
  }

  /* ե饰ȥΥץΥѥ */
  glCompileShader(fragShader);
  glGetShaderiv(fragShader, GL_COMPILE_STATUS, &compiled);
  printShaderInfoLog(fragShader);
  if (compiled == GL_FALSE) {
    fprintf(stderr, "Compile error in fragment shader.\n");
    exit(1);
  }

  /* ץ४֥Ȥκ */
  gl2Program = glCreateProgram();

  /* ֥ȤΥץؤϿ */
  glAttachShader(gl2Program, vertShader);
  glAttachShader(gl2Program, fragShader);

  /* ֥Ȥκ */
  glDeleteShader(vertShader);
  glDeleteShader(fragShader);

  /* attribute ѿ position  index  0 ˻ꤹ */
  glBindAttribLocation(gl2Program, 0, "position");

  /* ץΥ */
  glLinkProgram(gl2Program);
  glGetProgramiv(gl2Program, GL_LINK_STATUS, &linked);
  printProgramInfoLog(gl2Program);
  if (linked == GL_FALSE) {
    fprintf(stderr, "Link error.\n");
    exit(1);
  }

  /* Ѵ */
  lookAt(4.0f, 5.0f, 6.0f, 0.0f, 0.0f, 0.0f, 0.0f, 1.0f, 0.0f, temp0);

  /* ƩѴ */
  cameraMatrix(30.0f, 1.0f, 7.0f, 11.0f, temp1);

  /* ѴѴѤ projectionMatrix  */
  multiplyMatrix(temp0, temp1, projectionMatrix);

  /* uniform ѿ projectionMatrix ξ */
  projectionMatrixLocation = glGetUniformLocation(gl2Program, "projectionMatrix");

  /* ĺХåե֥Ȥ򣱤ĺ */
  glGenBuffers(1, &buffer);

  /* ĺХåե֥ȤˣĺʬΥΰݤ */
  glBindBuffer(GL_ARRAY_BUFFER, buffer);
  glBufferData(GL_ARRAY_BUFFER, sizeof (Position) * 4, NULL, GL_STATIC_DRAW);

  /* ĺХåե֥ȤΥץΥ֤˥ޥåפ */
  position = (Position *)glMapBuffer(GL_ARRAY_BUFFER, GL_WRITE_ONLY);

  /* ĺХåե֥ȤΥ˥ǡ񤭹 */
  position[0][0] =  0.9;
  position[0][1] =  0.9;
  position[1][0] = -0.9;
  position[1][1] =  0.9;
  position[2][0] = -0.9;
  position[2][1] = -0.9;
  position[3][0] =  0.9;
  position[3][1] = -0.9;

  /* ĺХåե֥ȤΥץΥ֤ڤΥ */
  glUnmapBuffer(GL_ARRAY_BUFFER);

  /* ĺХåե֥Ȥ */
  glBindBuffer(GL_ARRAY_BUFFER, 0);
}

/*
** ᥤץ
*/
int main(int argc, char *argv[])
{
  glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_RGB);
  glutCreateWindow(argv[0]);
  glutDisplayFunc(display);
  init();
  glutMainLoop();

  return 0;
}
